﻿Type=Activity
Version=3.82
B4A=true
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim MapCenter As GeoPoint
   Dim TileSource As String
   Dim ZoomLevel As Int
   Dim lati,longi As Double
   Dim lati1,Longi1 As Double
   
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim MapView1 As MapView
	' Dim MinimapOverlay1 As MinimapOverlay
   Dim ScaleBarOverlay1 As ScaleBarOverlay
   Dim TileSourceSpinner As Spinner
   
   '   create the SimpleLocationOverlay
   Dim SimpleLocationOverlay1 As SimpleLocationOverlay
   Dim firstcenterchanged=True As Boolean
End Sub 

Sub Activity_Create(FirstTime As Boolean)
	'Do not forget to load the layout file created with the visual designer. For example:
	'Activity.LoadLayout("Layout1")
	firstcenterchanged=False
	If File.ExternalWritable=False Then
      '   OSMDroid requires the use of external storage to cache tiles
      '   if no external storage is available then the MapView will display no tiles
      Msgbox("WARNING NO EXTERNAL STORAGE AVAILABLE","")
	End If  
	   '   no EventName is required as we don't need to listen for MapView events
   
   ' Activity.AddMenuItem("Do something", "DoSomething")
   
   
   '   pass an EventName when initializing the MapView
   '   MapView has two events: CenterChanged and ZoomChanged
   MapView1.Initialize("MapView1")
   Activity.AddView(MapView1, 0, 48dip, 100%x, 100%y-48dip)
   
   
   MapView1.SetMultiTouchEnabled(True)
   MapView1.SetZoomEnabled(True)
   
    If FirstTime Then
      MapCenter.Initialize(Main.latitude,Main.longitude)
      TileSource="Mapnik"
      ZoomLevel=6
	  lati1=Main.latitude
   	  Longi1=Main.longitude
   End If

   
   '   by default the map will zoom in on a double tap and also be draggable - no other user interface features are enabled
   
   '   enable the built in zoom controller - the map can now be zoomed in and out
   MapView1.SetZoomEnabled(True)
   
   '   enable the built in multi touch controller - the map can now be 'pinch zoomed'
   MapView1.SetMultiTouchEnabled(True)
   
   '   set the zoom level BEFORE the center (otherwise unpredictable map center may be set)
   ' MapView1.Zoom=MapView1.GetMaxZoomLevel
   ' pg die nächsten 2
   MapView1.SetTileSource("Mapnik")
   MapView1.Zoom=6
   
   If Main.latitude <> 0 Then
   	   MapView1.animateto(Main.latitude,Main.longitude)
	End If
	
	 MapView1.SetCenter3(MapCenter)
   
   ScaleBarOverlay1.Initialize(MapView1)
   ScaleBarOverlay1.SetEnabled (True)
   MapView1.AddOverlay(ScaleBarOverlay1)
   
   
   '   initialize the SimpleLocationOverlay and add it to the MapView
   SimpleLocationOverlay1.Initialize(MapView1)
   MapView1.AddOverlay(SimpleLocationOverlay1)
   
   
   '   set the SimpleLocationOverlay to display it's icon at the map center
   SimpleLocationOverlay1.SetMyLocation3(MapView1.GetCenter)
   '   note that there is no need to call the MapView Invalidate method here as that gets called (internally) when the MinimapOverlay is added to the MapView next
   
   '   ensure that the MinimapOverlay is the LAST overlay added to the MapView
   ' MinimapOverlay1.Initialize(MapView1)
   ' MapView1.AddOverlay(MinimapOverlay1)
   
   
   TileSourceSpinner.Initialize("TileSourceSelect")
   Activity.AddView(TileSourceSpinner, 0, 0, 100%x, 48dip)
   
   TileSourceSpinner.AddAll(MapView1.GetTileSources)
   TileSourceSpinner.Prompt="Select a TileSource"
   TileSourceSpinner.SelectedIndex=TileSourceSpinner.IndexOf(TileSource)
   TileSourceSelect_ItemClick(TileSourceSpinner.SelectedIndex, TileSourceSpinner.SelectedItem)
   

End Sub

Sub Activity_Resume

End Sub


Sub Activity_Pause (UserClosed As Boolean)
   MapCenter=MapView1.GetCenter
   TileSource=MapView1.GetTileSource
   ZoomLevel=MapView1.Zoom
   If UserClosed=True Then
   		
   	
   End If
End Sub

Sub DoSomething_Click
   '   set the map center to it's default location
   MapView1.SetCenter(52.75192, 0.40505)
   '   it is NOT required that the MapView Invalidate method is called
   '   changes to an Overlay require Invalidate but not changes to the MapView
   '   MapView1.Invalidate
End Sub

'   listen for the MapView CenterChanged event
Sub MapView1_CenterChanged
   Log("MapView1_CenterChanged")
   '   keep the SimpleLocationOverlay centered on the map center
   '   MapView.Invalidate is not called here as the MapView will (internally) invalidate itself when it's center changes
   SimpleLocationOverlay1.SetMyLocation3(MapView1.GetCenter)
   
   Dim g As GeoPoint
   	g=MapView1.GetCenter
   	Dim s As String
   	lati=g.Latitude
   	longi=g.Longitude
   	Msgbox ((lati-lati1) & " " & (longi-Longi1),firstcenterchanged)' 
	
   	If (firstcenterchanged=True) Then
		If (lati <> lati1) OR (longi <> Longi1) Then
			If Msgbox2 ("Koordinaten geändert. Übernehmen?","Bestätigung","ja","","Nein",Null)=DialogResponse.POSITIVE Then
				Dim s As String
				s = "update photos set lati='" & lati & "',longi='" & longi & "' where photoid='" & Main.photonumber & "'"
				Main.SQL1.ExecNonQuery (s)
				Main.latitude=lati
				Main.longitude=longi
			End If
		End If
	End If
	lati1=lati
	Longi1=longi
	firstcenterchanged=True
	
   
   
End Sub


Sub TileSourceSelect_ItemClick (Position As Int, Value As Object)
   MapView1.SetTileSource(Value)
'   MinimapOverlay1.SetTileSource(Value)
End Sub


'   listen for the MapView ZoomChanged event
Sub MapView1_ZoomChanged
   Log("MapView1_ZoomChanged ZoomLevel="&MapView1.Zoom)
End Sub

' http://www.haakseth.com/?p=30
' https://code.google.com/p/osmdroid/wiki/MobileAtlasCreator
' http://sourceforge.net/projects/mobac/?source=typ_redirect
' http://www.basic4ppc.com/android/forum/threads/osmdroid-mapview-for-b4a-tutorial.16310/#post-92702